import { JSONfn } from "./JSONfn";
export const defineWorker = (options = {}) => {
    self.onmessage = function (msg) {
        var request = JSON.parse(msg.data);
        var func = JSONfn.parse(request.func.body);
        var result;
        if (func) {
            result = func({
                state: request.state,
                ...options?.imports,
                onProgressUpdate: (dataUpdate) => self.postMessage(JSON.stringify({ dataUpdate: dataUpdate ?? null, onProgressUpdate: true }))
            });
        }
        if (result) {
            result = JSON.stringify(result);
        }
        self.postMessage(result);
    };
};
//# sourceMappingURL=defineWorker.js.map